
/*********************************************************
 * KeyboardTool    whmp 2015 11 16 
 *
 * an example and Tool for MRETV
 *
 * The ADC are all read, some at 1.1v ref some at v ref. They are also summed for
 * averaging or hysteresis. on the far right the first 6 are the summing values
 * the next 6 are the average values x 10 .
 *
 * A peek under the hood at the input streams. Abandon hope all who enter here.
 * Explore the ups and downs of the raw key stream and
 * see each keypress even multi byte keystrokes
 * Explore the ups and downs of the bit streams.
 * The space bar activates bitstream capture from the keyboard port.
 * A keyboard generates 11 bits see how the 8 bit SPI hardware handles it
 * with no overflow and no hanging bits left!
 * A few other values are shown as well.
 *
 * About Extension defines.
 *
 * Defining these in the MRETV library folder allows for extra optimisation and
 * improved performance. All examples are predefined in Arduino\libraries\MRETV\MRETVextensions.h
 *
 * for MasteRasterExtendedTransmissionVision 2
 **********************************************************/

#include <MrETV.h>
#ifndef KeyboardTool // make sure the extensions are set correctly
//#error Please define KeyboardTool in arduino\libraries\MRETV\MRETVextensions.h , See comments at start of sketch
#endif
/* **************  the extensions for this sketch
 #define firmwaremultiport  //get most of the 'under the hood' stuff running
 #define mergstreams
 #define userextension   background()
 #define translatekeys
 #define fontheight 8
 #define fakejoy2
 #define countframes
 ************************* */

#include "textfont.h"
#ifdef __AVR_ATmega168__
#define howtall (18)
#else 
#define howtall (21) // room for a title
#endif

uchar  Screenbuf[howtall*45];

// the full recommended ADC routine
// 6 for accumulating total, 6 for sum of ADC_SAMPLECOUNT samples
// ADC_SAMPLECOUNT default 10 max 64
#define ADC_SAMPLECOUNT 10
volatile uint analog[12];
uint analogindex=0;
void background(){
  uchar a;
  if(( Video.LineCount> Video.ScreenBottom)) { // once a frame
    // read adc's and take an average of ADC_SAMPLECOUNT samples
    union{  // for reading adc
      short val;
      uint8_t val8[2];
    };
    if(ADCSRA&_BV(ADSC)) return;// too early better miss a sample
    val8[0]=ADCL; // read conversion results
    val8[1]=ADCH;

    a=analogindex%8;
    switch(a){
    case 0: // first read after ref change so ignore it.
      break;
    case 1:
      analog[0]+=val; // store 0
      ADMUX=ADC_11V|1; // next  1 1v
      break;
    case 2: // first read after ref change so ignore it.
      break;
    case 3: //store 1 next 2 1v
    case 4: //store 2 next 3 1v
    case 5: //store 3 next 4 1v
    case 6: //store 4 next 5 1v
      analog[a-2]+=val;
      ADMUX=ADC_11V|(a-1);
      break;
    case 7:
      analog[5]+=val; //store 5
      ADMUX=ADC_5V|0; //next 0 5v
    }
    ADCSRA=ADC_START; // start next conversion
    analogindex=(analogindex+1)%(8*ADC_SAMPLECOUNT); // increment count
    if((analogindex<8)&&(analogindex>1) ){ // update totals
      analog[analogindex+4]=analog[analogindex-2];
      analog[analogindex-2]=0; // reset for new total
    }
  }
}

// the rest of this sketch will only be of interest to the very technical reader
void setup(){
}

void loop() {
  uchar d;
  uchar chin,a,b;
  uint lc;
  volatile int c;
  Screen.begin(textfont,Screenbuf, howtall*fontheight,45 , 20,25,1);
  Screen.fill(32);
  while(1)
  {
#ifdef __AVR_ATmega168__
    Screen_progstr(17,0,"A MRETV TOOL");
#else 
    Screen_progstr(20,0,"A MasterRasterExtendedTransmisionVision Tool");
#endif
    Screen.time(16,1);
    Screen_progstr(0,16,"fj");
    Screen_progstr(1,16,"F2J");
    Screen_progstr(2,16,"sk");
    Screen_progstr(0,0,"cnt");
    Screen_progstr(1,0,"in");
    Screen_progstr(2,0,"out");
    Screen_progstr(0,11,"PCIF");
    Screen_progstr(1,11,"SPDR");
    Screen_progstr(0,27,"cnt");
    Screen_progstr(1,27,"in");
    Screen_progstr(2,27,"out");
    Screen_progstr(0,41,"sync");
    Screen.hex(0,20,Video.fjin);
    Screen.hex(1,20,Video.f2jin);
    Screen.hex(2,20,Video.speckey);
    Screen.hex(0,5,Video.fpcount);
    Screen.hex(1,5,Video.fpin);
    Screen.hex(2,5,Video.fpout);
    if(PCIFR)Screen.hex(0,8,PCIFR);
    Screen.hex(1,8,SPDR);
    Screen.hex(0,24,Video.keycount);
    Screen.hex(1,24,Video.keyin);
    Screen.hex(2,24,Video.keyout);
    Screen.hex(0,32,Video.count);
    Screen.hex(1,32,Video.fsin);
    Screen.hex(2,32,Video.fsout);
    Screen.hex(0,38,Video.sync);
    Screen.hex(1,38,Video.datum);
    for(b=0;b<16;b++) {
      Screen.write(b+2,38,Video.buf[b]);
      Screen.hex(b+2,35,Video.buf[b]);
    }
    for(b=0;b<12;b++)  {
      while(Video.LineCount<200);
      Screen.fill(b+4,40,' ',-5);
      Screen.udec(analog[b]);
    }
    Screen.udec(13,15,Video.FrameCount);
    Screen.udec(14,15,Video.FrameHigh);
    Screen.hexint(13,26,Video.FrameCount);
    Screen.hexint(13,22,Video.FrameHigh);
    Screen.bin(14,22,Video.FrameCount);
    Screen.bin(15,22,Video.FrameCount/256);
    Screen.bin(16,22,Video.FrameHigh);
    Screen.bin(17,22,Video.FrameHigh/256);
    Screen.hex(15,15,Video.keysendcount);
    Screen.hex(16,15,Video.keysend);
    for(b=0;b<8;b++)  Screen.hex(b+4,21,Video.getraw(b));
    for(b=0;b<4;b++)  Screen.hex(b+4,27,Video.keybuf[b]);
    for (c=0;c<11;c++){
      Screen.bin( (c)+4,0,Video.fpbuf[c] );
    }
    lc=0;
    d=0;
    for (c=0;c<11;c++){
      for(b=0;b<8;b++){
        Screen.write(lc+4,(b+9)+(c*8)-(lc*11),Video.fpbuf[c]&_BV(b)?'1':'0');
        d++;
        if(d==11){
          lc++;
          d=0;
        }
      }
    }
    switch(  (chin=Video.readS())){
    case 0:  // nocharacter
      break;
      // MOUSE STUFF!!    0
    case'M':
      Video.EnableDataReporting();
      break;
    case'Q':
      Video.SetRemoteMode();
      break;
    case'S':
      Video.SetStreamMode();
      break;
    case'R':
      Video.ReadData();
      break;
      //reset whoever is on the port
    case'Z':
      Video.write2key(0xFF);
      break;
      //reset us
    case 0x0d:
      asm volatile("JMP 0x0000\n\t"::);
      //cleanup a bit
    case'0':
    case')':
      Video.fpcount=0;
      Video.fpin=0;
      Video.fpout=0;
      b=SPCR;
      SPCR=0;
      for (c=0;c<8;c++)Video.keybuf[c]=0;
      for (c=0;c<16;c++)Video.buf[c]=0;
      for(c=0;c<11;c++)Video.fpbuf[c]=0;
      Screen.fill(32);
      SPCR=b;
      break;
    case'^':
      Video.write2key(0xed);
      break;
    case'@':
      Video.write2key(0);
      break;
    case'#':
      Video.write2key(7);
      break;
    case'%':
      Video.write2key(255);
      break;
      // poor mans dual trace  oscilloscope
    case' ':
      Screen.fill(32);
      for (a=0;a<45;a++){
        Video.MasterRaster[a]='.';
        Video.MasterRaster[a+135]='.';
        Video.MasterRaster[a+45]='=';
        Video.MasterRaster[a+180]='=';
      }
      test();
      while(!(Video.readS()));
      Screen.fill(32);
      //return;
      break;
    default:
      // play with keyrepeat delay
      if(chin>='1'&&chin<='9'){
        Video.keyrate(chin-'1'+22);
      }
    }
  }
}

//decided to leave this in, needs to expand into a full sketch.
// for now clock and data line of firmware PS/2 port
void test(){
  uint a=0;
  volatile uchar b;
  while(Video.LineCount<5); // wait till previous key up done
  while(Video.LineCount>=5);
  while(Video.LineCount<5); // and all is quiet
  while(Video.LineCount>=5);


  cli(); // be quiet
  b=(PINB&(mclock+mdata));
  while(b==(PINB&(mclock+mdata)));  // wait till activity
  if((b&(mclock/*32*/))!=mclock/*32*/)Video.MasterRaster[a]='c'; // initial value
  if((b&(mdata/*8*/))!=mdata/*8*/)Video.MasterRaster[a+45]='_';
  for (a=1;a<220;a++){  // this is slow on purpose since the signals are slow.
    b=(PINB); // firmware ps2port hangs hear.
    if(!(a%45))a+=90;  // two lines for full 11 bits (I hope)
    if((b&(mclock/*32*/))!=mclock/*32*/)Video.MasterRaster[a]='c';  //display (and delay)
    if((b&(mdata/*8*/))!=mdata/*8*/)Video.MasterRaster[a+45]='_';
  }
  sei(); // back to action
}







